#include "asm86.h"
#include "ti86asm.inc"

userInt       = 2
userflags     = $23
_user_int_chk = $d2fd
_user_int_ram = $d2fe

.org _asm_exec_ram
 bit userInt,(iy+userflags)		;Is an interrupt enabled?
 jr z,InstallIt				;If not, install one.
 res userInt,(iy+userflags)		;Turn it off.
 ret

InstallIt:
 ld hl,CodeStart				;Start of new interrupt.
 ld de,_user_int_ram			;Interrupt storage area.
 ld bc,IntEnd-IntStart			;Run-Time-dynamic interrupt length.
 ldir
 ld a,(_user_int_ram)			;Make a checksum...
 ld hl,_user_int_ram+$27
 add a,(hl)
 ld hl,_user_int_ram+$4F
 add a,(hl)
 ld hl,_user_int_ram+$77
 add a,(hl)
 ld hl,_user_int_ram+$9F
 add a,(hl)
 ld hl,_user_int_ram+$C7
 add a,(hl)
 ld (_user_int_chk),a
 set userInt,(iy+userflags)		;Turn on new interrupt...
 ret

CodeStart:					;Marker for start of interrupt code.
.org _user_int_ram				;Makes JPs and CALLs work.

IntStart:						;For length math.
 push af						;We use a.
 ld a,(Count)					;Get the timer.
 dec a						;Decrement it.
 jr z,NoSlow					;If time's run out, actually move on.
 ld (Count),a					;Otherwise, put the count back.
 pop af						;Pop the af we put on the stack.
 pop af						;Pop the return address to the main interrupt.
 exx							;Retrieve the normal operation registers.
 ex af,af'
 ret							;Go back.
NoSlow:
 ld a,$03						;Reset count.
 ld (Count),a
 pop af						;Restore a.
 ret							;Return to interrupt.
Count:
 .db $03						;Only allow 1/3 of the interrupt to execute.
IntEnd:
.end
